diff --git a/ipc/ipdl/ipdl/type.py b/ipc/ipdl/ipdl/type.py
index 66a9fbd3ff..a6e8dbd845 100644
--- a/ipc/ipdl/ipdl/type.py
+++ b/ipc/ipdl/ipdl/type.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os, sys
 
 from ipdl.ast import CxxInclude, Decl, Loc, QualifiedId, State, StructDecl, TransitionStmt
@@ -10,6 +11,7 @@ from ipdl.ast import ASYNC, SYNC, INTR
 from ipdl.ast import IN, OUT, INOUT, ANSWER, CALL, RECV, SEND
 from ipdl.ast import NOT_NESTED, INSIDE_SYNC_NESTED, INSIDE_CPOW_NESTED
 import ipdl.builtin as builtin
+from functools import reduce
 
 _DELETE_MSG = '__delete__'
 
@@ -22,7 +24,7 @@ def _otherside(side):
 def unique_pairs(s):
     n = len(s)
     for i, e1 in enumerate(s):
-        for j in xrange(i+1, n):
+        for j in range(i+1, n):
             yield (e1, s[j])
 
 def cartesian_product(s1, s2):
@@ -36,8 +38,8 @@ class TypeVisitor:
         self.visited = set()
 
     def defaultVisit(self, node, *args):
-        raise Exception, "INTERNAL ERROR: no visitor for node type `%s'"% (
-            node.__class__.__name__)
+        raise Exception("INTERNAL ERROR: no visitor for node type `%s'"% (
+            node.__class__.__name__))
 
     def visitVoidType(self, v, *args):
         pass
@@ -125,8 +127,8 @@ class Type:
     def typename(self):
         return self.__class__.__name__
 
-    def name(self): raise Exception, 'NYI'
-    def fullname(self): raise Exception, 'NYI'
+    def name(self): raise Exception('NYI')
+    def fullname(self): raise Exception('NYI')
 
     def accept(self, visitor, *args):
         visit = getattr(visitor, 'visit'+ self.__class__.__name__, None)
@@ -506,7 +508,7 @@ def hasactor(type):
 
 def hasshmem(type):
     """Return true iff |type| is shmem or has it buried within."""
-    class found: pass
+    class found(Exception): pass
     class findShmem(TypeVisitor):
         def visitShmemType(self, s):  raise found()
     try:
@@ -517,7 +519,7 @@ def hasshmem(type):
 
 def hasfd(type):
     """Return true iff |type| is fd or has it buried within."""
-    class found: pass
+    class found(Exception): pass
     class findFD(TypeVisitor):
         def visitFDType(self, s):  raise found()
     try:
@@ -647,7 +649,7 @@ With this information, it finally type checks the AST.'''
 
     def reportErrors(self, errout):
         for error in self.errors:
-            print >>errout, error
+            print(error, file=errout)
 
 
 class TcheckVisitor(Visitor):
@@ -1581,7 +1583,7 @@ class Process:
         self.spawn.add(spawn)
 
     def iteredges(self):
-        for edgelist in self.edges.itervalues():
+        for edgelist in self.edges.values():
             for edge in edgelist:
                 yield edge
 
@@ -1690,7 +1692,7 @@ class ProcessGraph:
 
     @classmethod
     def iterbridges(cls):
-        for edges in cls.bridges.itervalues():
+        for edges in cls.bridges.values():
             for bridge in edges:
                 yield bridge
 
@@ -1711,7 +1713,7 @@ class ProcessGraph:
 
     @classmethod
     def iteropens(cls):
-        for edges in cls.opens.itervalues():
+        for edges in cls.opens.values():
             for opens in edges:
                 yield opens
 
@@ -1879,19 +1881,19 @@ class CheckProcessGraph(TcheckVisitor):
     # is a dag
     def visitTranslationUnit(self, tu):
         if 0:
-            print 'Processes'
+            print('Processes')
             for process in ProcessGraph.processes:
-                print '  ', process
+                print('  ', process)
                 for edge in process.iteredges():
-                    print '    ', edge
-            print 'Bridges'
-            for bridgeList in ProcessGraph.bridges.itervalues():
+                    print('    ', edge)
+            print('Bridges')
+            for bridgeList in ProcessGraph.bridges.values():
                 for bridge in bridgeList:
-                    print '  ', bridge
-            print 'Opens'
-            for opensList in ProcessGraph.opens.itervalues():
+                    print('  ', bridge)
+            print('Opens')
+            for opensList in ProcessGraph.opens.values():
                 for opens in opensList:
-                    print '  ', opens
+                    print('  ', opens)
 
 ##-----------------------------------------------------------------------------
 
@@ -2088,19 +2090,19 @@ direction as trigger |t|'''
                 errT2 = None
 
                 if 0 == len(U1) or 0 == len(U2):
-                    print "******* case 1"
+                    print("******* case 1")
                     raceError = True
                 elif 1 < len(U1) or 1 < len(U2):
                     raceError = True
                     # there are potentially many unpaired states; just
                     # pick two
-                    print "******* case 2"
+                    print("******* case 2")
                     for u1, u2 in cartesian_product(U1, U2):
                         if u1 != u2:
                             errT1, errT2 = u1, u2
                             break
                 elif U1 != U2:
-                    print "******* case 3"
+                    print("******* case 3")
                     raceError = True
                     for errT1 in U1: pass
                     for errT2 in U2: pass
@@ -2140,7 +2142,7 @@ direction as trigger |t|'''
                     root.loc,
                     "when starting from state `%s', actors of protocol `%s' cannot be deleted", root.state.name, p.name)
 
-        for ts in p.states.itervalues():
+        for ts in p.states.values():
             if ts.state is not State.DEAD and ts.state not in allvisited:
                 self.error(ts.loc,
                            "unreachable state `%s' in protocol `%s'",
diff --git a/ipc/ipdl/test/cxx/genIPDLUnitTests.py b/ipc/ipdl/test/cxx/genIPDLUnitTests.py
index 24026451bc..e1c29798b2 100644
--- a/ipc/ipdl/test/cxx/genIPDLUnitTests.py
+++ b/ipc/ipdl/test/cxx/genIPDLUnitTests.py
@@ -2,10 +2,11 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import string, sys
 
 def usage():
-    print >>sys.stderr, """
+    print("""
 %s template_file -t unit_tests... -e extra_protocols...
 
   TEMPLATE_FILE is used to generate to generate the unit-tester .cpp
@@ -13,7 +14,7 @@ def usage():
   EXTRA_PROTOCOLS are top-level protocols for subprocesses that can be
                   spawned in tests but are not unit tests in and of
                   themselves
-"""% (sys.argv[0])
+"""% (sys.argv[0]), file=sys.stderr)
     sys.exit(1)
 
 def main(argv):
diff --git a/ipc/pull-chromium.py b/ipc/pull-chromium.py
index c4a476e425..114360ca31 100644
--- a/ipc/pull-chromium.py
+++ b/ipc/pull-chromium.py
@@ -12,6 +12,7 @@ http://dev.chromium.org/developers/how-tos/get-the-code for details about
 doing this efficiently.
 """
 
+from __future__ import print_function
 import sys, os
 from subprocess import check_call
 from shutil import rmtree
@@ -19,11 +20,11 @@ from shutil import rmtree
 topsrcdir, chromiumtree, rev = sys.argv[1:]
 
 if not os.path.exists(os.path.join(topsrcdir, 'client.py')):
-    print >>sys.stderr, "Incorrect topsrcdir"
+    print("Incorrect topsrcdir", file=sys.stderr)
     sys.exit(1)
 
 if not os.path.exists(os.path.join(chromiumtree, 'src/DEPS')):
-    print >>sys.stderr, "Incorrect chromium directory, missing DEPS"
+    print("Incorrect chromium directory, missing DEPS", file=sys.stderr)
     sys.exit(1)
 
 check_call(['gclient', 'sync', '--force', '--revision=src@%s' % rev], cwd=chromiumtree)
diff --git a/js/src/builtin/embedjs.py b/js/src/builtin/embedjs.py
index c642aebd51..87a269259e 100644
--- a/js/src/builtin/embedjs.py
+++ b/js/src/builtin/embedjs.py
@@ -37,6 +37,7 @@
 # It uses the C preprocessor to process its inputs.
 
 from __future__ import with_statement
+from __future__ import print_function
 import re, sys, os, subprocess
 import shlex
 import which
@@ -53,7 +54,7 @@ def ToCAsciiArray(lines):
 def ToCArray(lines):
   result = []
   for chr in lines:
-    result.append(str(ord(chr)))
+    result.append(str(chr if isinstance(chr, int) else ord(chr)))
   return ", ".join(result)
 
 HEADER_TEMPLATE = """\
@@ -87,7 +88,7 @@ def embed(cxx, preprocessorOption, msgs, sources, c_out, js_out, namespace, env)
 
   js_out.write(processed)
   import zlib
-  compressed = zlib.compress(processed)
+  compressed = zlib.compress(processed.encode('utf-8'))
   data = ToCArray(compressed)
   c_out.write(HEADER_TEMPLATE % {
     'sources_type': 'unsigned char',
@@ -107,9 +108,9 @@ def preprocess(cxx, preprocessorOption, source, args = []):
   tmpOut = 'self-hosting-preprocessed.pp';
   outputArg = shlex.split(preprocessorOption + tmpOut)
 
-  with open(tmpIn, 'wb') as input:
+  with open(tmpIn, 'w') as input:
     input.write(source)
-  print(' '.join(cxx + outputArg + args + [tmpIn]))
+  print((' '.join(cxx + outputArg + args + [tmpIn])))
   result = subprocess.Popen(cxx + outputArg + args + [tmpIn]).wait()
   if (result != 0):
     sys.exit(result);
@@ -132,7 +133,7 @@ def messages(jsmsg):
 
 def get_config_defines(buildconfig):
   # Collect defines equivalent to ACDEFINES and add MOZ_DEBUG_DEFINES.
-  env = {key: value for key, value in buildconfig.defines.iteritems()
+  env = {key: value for key, value in buildconfig.defines.items()
          if key not in buildconfig.non_global_defines}
   for define in buildconfig.substs['MOZ_DEBUG_DEFINES']:
     env[define] = 1
diff --git a/js/src/builtin/intl/make_intl_data.py b/js/src/builtin/intl/make_intl_data.py
index 7cd4b2c652..fb6db50b88 100644
--- a/js/src/builtin/intl/make_intl_data.py
+++ b/js/src/builtin/intl/make_intl_data.py
@@ -31,20 +31,23 @@ import codecs
 import sys
 import tarfile
 import tempfile
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 from contextlib import closing
 from functools import partial
-from itertools import chain, ifilter, ifilterfalse, imap, izip_longest, groupby, tee
+from itertools import chain, groupby, tee
 from operator import attrgetter, itemgetter
-from urlparse import urlsplit
+from urllib.parse import urlsplit
 from zipfile import ZipFile
+import six
+from six.moves import filterfalse
+from itertools import zip_longest
 
 # From https://docs.python.org/3/library/itertools.html
 def grouper(iterable, n, fillvalue=None):
     "Collect data into fixed-length chunks or blocks"
     # grouper('ABCDEFG', 3, 'x') --> ABC DEF Gxx"
     args = [iter(iterable)] * n
-    return izip_longest(*args, fillvalue=fillvalue)
+    return zip_longest(*args, fillvalue=fillvalue)
 
 def writeMappingHeader(println, description, source, url):
     if type(description) is not list:
@@ -64,7 +67,7 @@ def writeMappingsVar(println, mapping, name, description, source, url):
     println(u"")
     writeMappingHeader(println, description, source, url)
     println(u"var {0} = {{".format(name))
-    for (key, value) in sorted(mapping.items(), key=itemgetter(0)):
+    for (key, value) in sorted(list(mapping.items()), key=itemgetter(0)):
         println(u'    "{0}": "{1}",'.format(key, value))
     println(u"};")
 
@@ -103,7 +106,7 @@ bool js::intl::LanguageTag::{0}({1} {2}) {{
     # Sort the subtags by length. That enables using an optimized comparator
     # for the binary search, which only performs a single |memcmp| for multiple
     # of two subtag lengths.
-    mappings_keys = mappings.keys() if type(mappings) == dict else mappings
+    mappings_keys = list(mappings.keys()) if type(mappings) == dict else mappings
     for (length, subtags) in groupby(sorted(mappings_keys, key=len), len):
         # Omit the length check if the current length is the maximum length.
         if length != tag_maxlength:
@@ -198,7 +201,7 @@ void js::intl::LanguageTag::performComplexLanguageMappings() {
     # Merge duplicate language entries.
     language_aliases = {}
     for (deprecated_language, (language, script, region)) in (
-        sorted(complex_language_mappings.items(), key=itemgetter(0))
+        sorted(list(complex_language_mappings.items()), key=itemgetter(0))
     ):
         key = (language, script, region)
         if key not in language_aliases:
@@ -208,7 +211,7 @@ void js::intl::LanguageTag::performComplexLanguageMappings() {
 
     first_language = True
     for (deprecated_language, (language, script, region)) in (
-        sorted(complex_language_mappings.items(), key=itemgetter(0))
+        sorted(list(complex_language_mappings.items()), key=itemgetter(0))
     ):
         key = (language, script, region)
         if deprecated_language in language_aliases[key]:
@@ -265,7 +268,7 @@ void js::intl::LanguageTag::performComplexRegionMappings() {
     # Merge duplicate region entries.
     region_aliases = {}
     for (deprecated_region, (default, non_default_replacements)) in (
-        sorted(complex_region_mappings.items(), key=itemgetter(0))
+        sorted(list(complex_region_mappings.items()), key=itemgetter(0))
     ):
         key = hash_key(default, non_default_replacements)
         if key not in region_aliases:
@@ -275,7 +278,7 @@ void js::intl::LanguageTag::performComplexRegionMappings() {
 
     first_region = True
     for (deprecated_region, (default, non_default_replacements)) in (
-        sorted(complex_region_mappings.items(), key=itemgetter(0))
+        sorted(list(complex_region_mappings.items()), key=itemgetter(0))
     ):
         key = hash_key(default, non_default_replacements)
         if deprecated_region in region_aliases[key]:
@@ -380,7 +383,7 @@ bool js::intl::LanguageTag::performVariantMappings(JSContext* cx) {
     first_variant = True
 
     for (deprecated_variant, (type, replacement)) in (
-        sorted(variant_mappings.items(), key=itemgetter(0))
+        sorted(list(variant_mappings.items()), key=itemgetter(0))
     ):
         if_kind = u"if" if first_variant else u"else if"
         first_variant = False
@@ -498,7 +501,7 @@ bool js::intl::LanguageTag::updateGrandfatheredMappings(JSContext* cx) {
 
     is_first = True
 
-    for (tag, modern) in sorted(grandfathered_mappings.items(), key=itemgetter(0)):
+    for (tag, modern) in sorted(list(grandfathered_mappings.items()), key=itemgetter(0)):
         tag_match = re_unicode_locale_id.match(tag)
         assert tag_match is not None
 
@@ -1152,7 +1155,7 @@ static bool IsCanonicallyCasedTransformType(mozilla::Span<const char> type) {
                               "const LanguageSubtag&", "language",
                               "IsStructurallyValidLanguageTag",
                               "IsCanonicallyCasedLanguageTag",
-                              complex_language_mappings.keys(), language_maxlength,
+                              list(complex_language_mappings.keys()), language_maxlength,
                               "Language subtags with complex mappings.", source, url)
     writeMappingsBinarySearch(println, "regionMapping",
                               "RegionSubtag&", "region",
@@ -1164,7 +1167,7 @@ static bool IsCanonicallyCasedTransformType(mozilla::Span<const char> type) {
                               "const RegionSubtag&", "region",
                               "IsStructurallyValidRegionTag",
                               "IsCanonicallyCasedRegionTag",
-                              complex_region_mappings.keys(), region_maxlength,
+                              list(complex_region_mappings.keys()), region_maxlength,
                               "Region subtags with complex mappings.", source, url)
 
     writeComplexLanguageTagMappings(println, complex_language_mappings,
@@ -1360,7 +1363,7 @@ def updateCLDRLangTags(args):
             readFiles(cldr_file)
     else:
         print("Downloading CLDR core.zip...")
-        with closing(urllib2.urlopen(url)) as cldr_file:
+        with closing(six.moves.urllib.request.urlopen(url)) as cldr_file:
             cldr_data = io.BytesIO(cldr_file.read())
             readFiles(cldr_data)
 
@@ -1435,20 +1438,20 @@ class TzDataFile:
 
 def validateTimeZones(zones, links):
     """ Validate the zone and link entries. """
-    linkZones = set(links.viewkeys())
+    linkZones = set(six.viewkeys(links))
     intersect = linkZones.intersection(zones)
     if intersect:
         raise RuntimeError("Links also present in zones: %s" % intersect)
 
     zoneNames = set(z.name for z in zones)
-    linkTargets = set(links.viewvalues())
+    linkTargets = set(six.viewvalues(links))
     if not linkTargets.issubset(zoneNames):
         raise RuntimeError("Link targets not found: %s" % linkTargets.difference(zoneNames))
 
 def partition(iterable, *predicates):
     def innerPartition(pred, it):
         it1, it2 = tee(it)
-        return (ifilter(pred, it1), ifilterfalse(pred, it2))
+        return (filter(pred, it1), filterfalse(pred, it2))
     if len(predicates) == 0:
         return iterable
     (left, right) = innerPartition(predicates[0], iterable)
@@ -1459,7 +1462,7 @@ def partition(iterable, *predicates):
 def listIANAFiles(tzdataDir):
     def isTzFile(d, m, f):
         return m(f) and d.isfile(d.resolve(f))
-    return ifilter(partial(isTzFile, tzdataDir, re.compile("^[a-z0-9]+$").match), tzdataDir.listdir())
+    return filter(partial(isTzFile, tzdataDir, re.compile("^[a-z0-9]+$").match), tzdataDir.listdir())
 
 def readIANAFiles(tzdataDir, files):
     """ Read all IANA time zone files from the given iterable. """
@@ -1507,7 +1510,7 @@ def readIANATimeZones(tzdataDir, ignoreBackzone, ignoreFactory):
     # Merge with backzone data.
     if not ignoreBackzone:
         zones |= backzones
-        links = {name: target for name, target in links.iteritems() if name not in backzones}
+        links = {name: target for name, target in links.items() if name not in backzones}
         links.update(backlinks)
 
     validateTimeZones(zones, links)
@@ -1644,7 +1647,7 @@ def readICUTimeZonesFromZoneInfo(icuTzDir):
         elif name == namesKey:
             tzNames.extend(value)
 
-    links = dict((Zone(tzNames[zone]), tzNames[target]) for (zone, target) in tzLinks.iteritems())
+    links = dict((Zone(tzNames[zone]), tzNames[target]) for (zone, target) in tzLinks.items())
     zones = set([Zone(v) for v in tzNames if Zone(v) not in links])
 
     validateTimeZones(zones, links)
@@ -1685,7 +1688,7 @@ def readICUTimeZones(icuDir, icuTzDir, ignoreFactory):
     if notFoundInZoneInfo64:
         raise RuntimeError("Missing time zones in zoneinfo64.txt: %s" % notFoundInZoneInfo64)
 
-    notFoundInZoneInfo64 = [zone for zone in typesLinks.iterkeys() if not inZoneInfo64(zone)]
+    notFoundInZoneInfo64 = [zone for zone in typesLinks.keys() if not inZoneInfo64(zone)]
     if notFoundInZoneInfo64:
         raise RuntimeError("Missing time zones in zoneinfo64.txt: %s" % notFoundInZoneInfo64)
 
@@ -1697,8 +1700,8 @@ def readICUTimeZones(icuDir, icuTzDir, ignoreFactory):
                  (zone for zone in typesZones)
                ))
     icuLinks = dict(chain(
-                 ((zone, target) for (zone, target) in zoneinfoLinks.iteritems() if zone not in typesZones),
-                 ((zone, target) for (zone, target) in typesLinks.iteritems())
+                 ((zone, target) for (zone, target) in zoneinfoLinks.items() if zone not in typesZones),
+                 ((zone, target) for (zone, target) in typesLinks.items())
                ))
 
     return (icuZones, icuLinks)
@@ -1801,7 +1804,7 @@ def findIncorrectICUZones(ianaZones, ianaLinks, icuZones, icuLinks, ignoreBackzo
 
     # Remove unnecessary UTC mappings.
     utcnames = ["Etc/UTC", "Etc/UCT", "Etc/GMT"]
-    result = ifilterfalse(lambda (zone, target): zone.name in utcnames, result)
+    result = filterfalse(lambda zone_target1: zone_target1[0].name in utcnames, result)
 
     return sorted(result, key=itemgetter(0))
 
@@ -1813,28 +1816,28 @@ def findIncorrectICULinks(ianaZones, ianaLinks, icuZones, icuLinks):
     isICUZone = lambda zone: zone in icuZones
 
     # All links should be present in ICU.
-    missingTimeZones = [zone for zone in ianaLinks.iterkeys() if not isICUTimeZone(zone)]
+    missingTimeZones = [zone for zone in ianaLinks.keys() if not isICUTimeZone(zone)]
     if missingTimeZones:
         raise RuntimeError("Not all zones are present in ICU, did you forget "
                            "to run intl/update-tzdata.sh? %s" % missingTimeZones)
 
     # Links which are only present in ICU?
-    additionalTimeZones = [zone for zone in icuLinks.iterkeys() if not isIANATimeZone(zone)]
+    additionalTimeZones = [zone for zone in icuLinks.keys() if not isIANATimeZone(zone)]
     if additionalTimeZones:
         raise RuntimeError("Additional links present in ICU, did you forget "
                            "to run intl/update-tzdata.sh? %s" % additionalTimeZones)
 
     result = chain(
         # IANA links which have a different target in ICU.
-        ((zone, target, icuLinks[zone]) for (zone, target) in ianaLinks.iteritems() if isICULink(zone) and target != icuLinks[zone]),
+        ((zone, target, icuLinks[zone]) for (zone, target) in ianaLinks.items() if isICULink(zone) and target != icuLinks[zone]),
 
         # IANA links which are zones in ICU.
-        ((zone, target, zone.name) for (zone, target) in ianaLinks.iteritems() if isICUZone(zone))
+        ((zone, target, zone.name) for (zone, target) in ianaLinks.items() if isICUZone(zone))
     )
 
     # Remove unnecessary UTC mappings.
     utcnames = ["Etc/UTC", "Etc/UCT", "Etc/GMT"]
-    result = ifilterfalse(lambda (zone, target, icuTarget): target in utcnames and icuTarget in utcnames, result)
+    result = filterfalse(lambda zone_target_icuTarget: zone_target_icuTarget[1] in utcnames and zone_target_icuTarget[2] in utcnames, result)
 
     return sorted(result, key=itemgetter(0))
 
@@ -1919,16 +1922,16 @@ def processTimeZones(tzdataDir, icuDir, icuTzDir, version, ignoreBackzone, ignor
 def updateBackzoneLinks(tzdataDir, links):
     (backzoneZones, backzoneLinks) = readIANAFiles(tzdataDir, ["backzone"])
     (stableZones, updatedLinks, updatedZones) = partition(
-        links.iteritems(),
+        links.items(),
         # Link not changed in backzone.
-        lambda (zone, target): zone not in backzoneLinks and zone not in backzoneZones,
+        lambda zone_target2: zone_target2[0] not in backzoneLinks and zone_target2[0] not in backzoneZones,
         # Link has a new target.
-        lambda (zone, target): zone in backzoneLinks,
+        lambda zone_target3: zone_target3[0] in backzoneLinks,
     )
     # Keep stable zones and links with updated target.
     return dict(chain(
                 stableZones,
-                imap(lambda (zone, target): (zone, backzoneLinks[zone]), updatedLinks)
+                map(lambda zone_target: (zone_target[0], backzoneLinks[zone_target[0]]), updatedLinks)
            ))
 
 def generateTzDataLinkTestContent(testDir, version, fileName, description, links):
@@ -1981,11 +1984,11 @@ def generateTzDataTestBackwardLinks(tzdataDir, version, ignoreBackzone, testDir)
         testDir, version,
         "timeZone_backward_links.js",
         u"// Link names derived from IANA Time Zone Database, backward file.",
-        links.iteritems()
+        links.items()
     )
 
 def generateTzDataTestNotBackwardLinks(tzdataDir, version, ignoreBackzone, testDir):
-    tzfiles = ifilterfalse({"backward", "backzone"}.__contains__, listIANAFiles(tzdataDir))
+    tzfiles = filterfalse({"backward", "backzone"}.__contains__, listIANAFiles(tzdataDir))
     (zones, links) = readIANAFiles(tzdataDir, tzfiles)
 
     if not ignoreBackzone:
@@ -1995,7 +1998,7 @@ def generateTzDataTestNotBackwardLinks(tzdataDir, version, ignoreBackzone, testD
         testDir, version,
         "timeZone_notbackward_links.js",
         u"// Link names derived from IANA Time Zone Database, excluding backward file.",
-        links.iteritems()
+        links.items()
     )
 
 def generateTzDataTestBackzone(tzdataDir, version, ignoreBackzone, testDir):
@@ -2056,7 +2059,7 @@ def generateTzDataTestBackzoneLinks(tzdataDir, version, ignoreBackzone, testDir)
         testDir, version,
         "timeZone_backzone_links.js",
         comment +  u"// Backzone links derived from IANA Time Zone Database.",
-        ((zone, target if not ignoreBackzone else links[zone]) for (zone, target) in backlinks.iteritems())
+        ((zone, target if not ignoreBackzone else links[zone]) for (zone, target) in backlinks.items())
     )
 
 def generateTzDataTests(tzdataDir, version, ignoreBackzone, testDir):
@@ -2114,7 +2117,7 @@ def updateTzdata(topsrcdir, args):
 
     if tzDir is None:
         print("Downloading tzdata file...")
-        with closing(urllib2.urlopen(url)) as tzfile:
+        with closing(six.moves.urllib.request.urlopen(url)) as tzfile:
             fname = urlsplit(tzfile.geturl()).path.split("/")[-1]
             with tempfile.NamedTemporaryFile(suffix=fname) as tztmpfile:
                 print("File stored in %s" % tztmpfile.name)
@@ -2146,7 +2149,7 @@ static inline bool Is{0}Type(
 
     linear_search_max_length = 4
 
-    needs_binary_search = any(len(replacements.items()) > linear_search_max_length
+    needs_binary_search = any(len(list(replacements.items())) > linear_search_max_length
                               for replacements in mapping.values())
 
     if needs_binary_search:
@@ -2220,7 +2223,7 @@ const char* js::intl::LanguageTag::replace{0}ExtensionType(
 
     # Merge duplicate keys.
     key_aliases = {}
-    for (key, replacements) in sorted(mapping.items(), key=itemgetter(0)):
+    for (key, replacements) in sorted(list(mapping.items()), key=itemgetter(0)):
         hash_key = to_hash_key(replacements)
         if hash_key not in key_aliases:
             key_aliases[hash_key] = []
@@ -2228,7 +2231,7 @@ const char* js::intl::LanguageTag::replace{0}ExtensionType(
             key_aliases[hash_key].append(key)
 
     first_key = True
-    for (key, replacements) in sorted(mapping.items(), key=itemgetter(0)):
+    for (key, replacements) in sorted(list(mapping.items()), key=itemgetter(0)):
         hash_key = to_hash_key(replacements)
         if key in key_aliases[hash_key]:
             continue
@@ -2242,7 +2245,7 @@ const char* js::intl::LanguageTag::replace{0}ExtensionType(
   {} ({}) {{""".format(if_kind, cond).strip("\n"))
         first_key = False
 
-        replacements = sorted(replacements.items(), key=itemgetter(0))
+        replacements = sorted(list(replacements.items()), key=itemgetter(0))
 
         if len(replacements) > linear_search_max_length:
             types = [t for (t, _) in replacements]
diff --git a/js/src/ctypes/libffi/generate-darwin-source-and-headers.py b/js/src/ctypes/libffi/generate-darwin-source-and-headers.py
index 964e861d43..b53ce68c9c 100644
--- a/js/src/ctypes/libffi/generate-darwin-source-and-headers.py
+++ b/js/src/ctypes/libffi/generate-darwin-source-and-headers.py
@@ -194,7 +194,7 @@ def generate_source_and_headers(generate_osx=True, generate_ios=True):
         build_target(desktop64_platform, platform_headers)
 
     mkdir_p('darwin_common/include')
-    for header_name, tag_tuples in platform_headers.iteritems():
+    for header_name, tag_tuples in platform_headers.items():
         basename, suffix = os.path.splitext(header_name)
         with open(os.path.join('darwin_common/include', header_name), 'w') as header:
             for tag_tuple in tag_tuples:
diff --git a/js/src/devtools/automation/autospider.py b/js/src/devtools/automation/autospider.py
index 030d8c98d7..0d9366a87d 100755
--- a/js/src/devtools/automation/autospider.py
+++ b/js/src/devtools/automation/autospider.py
@@ -1,5 +1,6 @@
 #!/usr/bin/env python
 
+from __future__ import print_function
 import argparse
 import json
 import logging
@@ -106,7 +107,7 @@ def set_vars_from_script(script, vars):
                 var, value = m.groups()
                 if var in tograb:
                     env[var] = value
-                    print("Setting %s = %s" % (var, value))
+                    print(("Setting %s = %s" % (var, value)))
                 if var.startswith("ORIGINAL_"):
                     originals[var[9:]] = value
 
@@ -290,7 +291,7 @@ if not args.nobuild:
     configure = os.path.join(DIR.js_src, 'configure')
     if not os.path.exists(configure):
         shutil.copyfile(configure + ".in", configure)
-        os.chmod(configure, 0755)
+        os.chmod(configure, 0o755)
 
     # Run configure; make
     run_command(['sh', '-c', posixpath.join(PDIR.js_src, 'configure') + ' ' + CONFIGURE_ARGS], check=True)
@@ -359,11 +360,11 @@ if 'jstests' in test_suites:
 # FIXME bug 1291449: This would be unnecessary if we could run msan with -mllvm
 # -msan-keep-going, but in clang 3.8 it causes a hang during compilation.
 if variant.get('ignore-test-failures'):
-    print("Ignoring test results %s" % (results,))
+    print(("Ignoring test results %s" % (results,)))
     results = [0]
 
 if args.variant in ('tsan', 'msan'):
-    files = filter(lambda f: f.startswith("sanitize_log."), os.listdir(OUTDIR))
+    files = [f for f in os.listdir(OUTDIR) if f.startswith("sanitize_log.")]
     fullfiles = [os.path.join(OUTDIR, f) for f in files]
 
     # Summarize results
@@ -384,11 +385,11 @@ if args.variant in ('tsan', 'msan'):
     summary_filename = os.path.join(env['MOZ_UPLOAD_DIR'], "%s_summary.txt" % args.variant)
     with open(summary_filename, 'wb') as outfh:
         for location, count in sites.most_common():
-            print >> outfh, "%d %s" % (count, location)
-    print(open(summary_filename, 'rb').read())
+            print("%d %s" % (count, location), file=outfh)
+    print((open(summary_filename, 'rb').read()))
 
     if 'max-errors' in variant:
-        print("Found %d errors out of %d allowed" % (len(sites), variant['max-errors']))
+        print(("Found %d errors out of %d allowed" % (len(sites), variant['max-errors'])))
         if len(sites) > variant['max-errors']:
             results.append(1)
 
